
		.title	CRLF2LF v0.10 (C)1995 Tachibana Eririn

program:	.reg	'CRLF2LF'
version:	.reg	'v0.10'
copyright:	.reg	'(C)1995 Tachibana Eririn'


* Include File -------------------------------- *

		.include	ERIRIN.MAC
		.include	DOSCALL.MAC
		.include	DecHUPAIR.MAC


* Fixed Number -------------------------------- *

stack_size:	.equ	 8*1024
argbuf_size:	.equ	32*1024

EXIT_SUCCESS:	.equ	0
EXIT_FAILURE:	.equ	1

* Offset Table Section ------------------------ *

		.offset	0
file_count:	.ds	1
output_handle:	.ds	1
output_file:	.ds.l	1
		.ds.b	stack_size
stack_end:
arg_buf:	.ds.b	argbuf_size
work_size:


* Text Section -------------------------------- *

		.text
start_:
		HUPAIR
*
		pea	(PSPSIZE+end_-start_+work_size)
		pea	(MEPSIZE,a0)
		DOS	_SETBLOCK
		tst.l	d0
		bmi	setblock_error
		lea	(end_,pc),a6
		lea	(stack_end,a6),sp

		clr	(file_count,a6)
		st	(output_handle,a6)
		lea	(default_output_file,pc),a0
		move.l	a0,(output_file,a6)

		.data
default_output_file:
		.dc.b	'-',0
		.text

		addq.l	#1,a2
		lea	(a2),a0
		lea	(arg_buf-stack_end,sp),a1
		bsr	DecodeHUPAIR
~argp_bak:	.reg	a0
~argp:		.reg	a1
~argc:		.reg	d7
		move	d0,~argc

		bra	arg_loop_next
arg_loop:
		lea	(~argp),~argp_bak
		move.b	(~argp)+,d0
		beq	arg_loop_next
		cmpi.b	#'-',d0
		beq	check_option

		clr	-(sp)
		move.l	~argp_bak,-(sp)
		DOS	_OPEN
		addq.l	#6,sp
		tst.l	d0
		bmi	open_error
		bsr	crlf2lf_file

		addq	#1,(file_count,a6)
		bra	arg_loop_skip

check_option:
		move.b	(~argp)+,d0
		beq	read_from_stdin
		bsr	tolower
		cmpi.b	#'?',d0
		beq	@f
		cmpi.b	#'h',d0
@@
		beq	print_usage
		cmpi.b	#'o',d0
		beq	option_o

		bra	option_error

option_o:
		DOS	_ALLCLOSE		ȑOoutputt@C
@@
		tst.b	(~argp)+
		dbne	~argc,@b
		beq	no_filename_error

		subq.l	#1,~argp
		lea	(~argp),~argp_bak
		move.l	~argp,(output_file,a6)
		bra	arg_loop_skip

arg_loop_skip:
		bsr	skip_string
		lea	(~argp_bak),~argp
arg_loop_next:
		dbra	~argc,arg_loop

		tst	(file_count,a6)
		bne	@f

		bsr	crlf2lf_stdin
@@
		DOS	_EXIT


*  crlf2lf_file Ăяo

read_from_stdin:
		pea	(arg_loop_next,pc)
		bra	crlf2lf_stdin

crlf2lf_stdin:
		moveq	#STDIN,d0
		bra	crlf2lf_file


* crlf2lf ϊ[` C[v ----------- *

~chk_eof:	.reg	a4
~lf_code:	.reg	d4
~cr_code:	.reg	d5
~memblock_adr:	.reg	a5
~memblock_size:	.reg	d6
~file_handle:	.reg	d7			high:output / low:input

crlf2lf_file:
usereg:		.reg	d7/a0-a1
		PUSH	usereg

		lea	(chk_eof_dummy,pc),~chk_eof
		move	d0,~file_handle
		move	d0,-(sp)
		clr	-(sp)
		DOS	_IOCTRL
		addq.l	#4,sp
		tst.l	d0
		bmi	ioctrl_error
		tst	d0
		bpl	@f			ʂ̃t@C
		btst	#5,d0
		bne	@f			RAW [h

		addq.l	#chk_eof-chk_eof_dummy,~chk_eof
@@

		.if	0
		bsr	get_filesize
		move.l	d0,~infile_size
		beq	crlf2lf_end
		bmi	seek_error
		.endif

		bsr	malloc
		bmi	memory_error
		move.l	d0,~memblock_size
		movea.l	a0,~memblock_adr
		bmi	memory_error

		swap	~file_handle
		move	(output_handle,a6),~file_handle
		bpl	output_file_already

		moveq	#STDOUT,d0		-o - Ȃ STDOUT ɏo
		move.l	(output_file,a6),a0
		cmpi.b	#'-',(a0)
		bne	@f
		tst.b	(1,a0)
		beq	output_file_opened
@@
		move	#ARCHIVE,-(sp)
		move.l	a0,-(sp)
		DOS	_CREATE
		addq.l	#6,sp
		tst.l	d0
		bmi	create_error
output_file_opened:
		move	d0,(output_handle,a6)
		move	d0,~file_handle
output_file_already:
		swap	~file_handle		high:output / low:input

		moveq	#LF,~lf_code
		moveq	#CR,~cr_code
		bra	crlf2lf_next

crlf2lf_loop:
		lea	(~memblock_adr),a0
		lea	(~memblock_adr),a1

		subq.l	#1,d0
		swap	d0
crlf2lf_loop_h:
		swap	d0
crlf2lf_loop_l:
		move.b	(a0)+,d2
		move.b	d2,(a1)+
		cmp.b	d2,~cr_code
		dbeq	d0,crlf2lf_loop_l
		bne	crlf2lf_loop_h_pre

		tst.l	d0
		bne	check_crlf

* ǂݍ񂾍Ō1oCg CR 
		subq.l	#1,d1
		move	#SEEK_CUR,-(sp)
		moveq	#-1,d0
		move.l	d0,-(sp)
		move	~file_handle,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		tst.l	d0
		bmi	seek_error

		bra	crlf2lf_write

check_crlf:
		cmp.b	(a0),~lf_code		CR ̎̕ LF ?
		dbeq	d0,crlf2lf_loop_l
		bne	crlf2lf_loop_h_pre

		addq.l	#1,a0
		move.b	~lf_code,(-1,a1)
		subq.l	#1,d0			cꕶ炷
		subq.l	#1,d1			oʂV
		dbra	d0,crlf2lf_loop_l
crlf2lf_loop_h_pre:
		swap	d0
		dbra	d0,crlf2lf_loop_h

crlf2lf_write:
		move.l	d1,-(sp)		read length
		move.l	~memblock_adr,-(sp)
		move.l	~file_handle,-(sp)
		move	(sp)+,(sp)
		DOS	_WRITE
		addq.l	#6,sp
		move.l	(sp)+,d1
		tst.l	d0
		bmi	write_error
		cmp.l	d0,d1
		bhi	no_diskf_error
crlf2lf_next:
		move.l	~chk_eof,d0
		beq	crlf2lf_end		O̓ǂݍ݂ EOT/EOF o

		move.l	~memblock_size,-(sp)
		move.l	~memblock_adr,-(sp)
		move	~file_handle,-(sp)
		DOS	_READ
		lea	(10,sp),sp
		move.l	d0,d1
		bmi	read_error

		jsr	(~chk_eof)
		bne	crlf2lf_loop
crlf2lf_end:
		move.l	~memblock_adr,-(sp)
		DOS	_MFREE
		addq.l	#4,sp

		POP	usereg
chk_eof_dummy:
		rts

* COOKED [h̃LN^foCX̓͂̏ꍇ́A^D,^Z œ͂ł؂

chk_eof:
		lea	(~memblock_adr),a0
		moveq	#0,d0
		bra	chk_eof_next
chk_eof_loop:
		move.b	(a0)+,d2
		cmpi.b	#EOF,d2
		beq	chk_eof_found
		subq.b	#EOT,d2
		beq	chk_eof_found

		addq.l	#1,d0
chk_eof_next:
		subq.l	#1,d1
		bcc	chk_eof_loop
@@
		move.l	d0,d1
		rts
chk_eof_found:
		suba.l	~chk_eof,~chk_eof
		bra	@b


* Sub Routine --------------------------------- *

tolower:
		cmpi.b	#'A',d0
		bmi	@f
		cmpi.b	#'Z',d0
		bhi	@f
		ori.b	#$20,d0
@@
		rts

skip_string:
		tst.b	(a0)+
		bne	skip_string
		rts

		.if	0

* gp
* in	d0.w	file handle
* out	d0.l	file size
get_filesize:
		move.l	d1,-(sp)

		move	#SEEK_END,-(sp)
		clr.l	-(sp)
		move	d0,-(sp)
		DOS	_SEEK
		move.l	d0,d1
		bmi	@f

		clr	(6,sp)
		DOS	_SEEK
		tst.l	d0
		bmi	@f
		
		move.l	d1,d0
@@
		addq.l	#8,sp
		move.l	(sp)+,d1
		rts

		.endif

		.if	0

* gp
* in	d0.l	mۂő̑傫
* out	d0.l	mۏo傫(ȂG[)
*	a0.l	mۂubÑAhX

malloc_min:	.equ	1024
malloc:
		move.l	d1,-(sp)
		move.l	d0,d1

		pea	($00ff_ffff)
		DOS	_MALLOC
		and.l	(sp)+,d0
		cmpi.l	#malloc_min,d0
		bmi	malloc_error_return

		cmp.l	d0,d1
		bcc	@f
		move.l	d1,d0
@@
		move.l	d0,-(sp)
		DOS	_MALLOC
		movea.l	d0,a0
		move.l	(sp)+,d0
malloc_error_return:
		move	(sp)+,d1
		rts

		.endif

* out	d0.l	mۏo傫(ȂG[)
*	a0.l	mۂubÑAhX

malloc_min:	.equ	1024
malloc:
		pea	($00ff_ffff)
		DOS	_MALLOC
		and.l	d0,(sp)
		lea	(malloc_min),a0
		cmpa.l	(sp),a0
		bls	@f

		move.l	a0,(sp)
@@
		DOS	_MALLOC
		movea.l	(sp)+,a0
		tst.l	d0
		exg	d0,a0
		rts


* G[ ---------------------------------- *

print_usage:
		pea	(usage_mes,pc)
		DOS	_PRINT
		DOS	_EXIT

		.data
usage_mes:
		.dc.b	program,SPC,version,SPC,copyright,CR,LF
		.dc.b	'usage : ',program,' [-o outfile] [infile] ...',CR,LF
		.dc.b	0
		.text

* ̑̃G[(ԂďI)

open_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	't@CI[vo܂.',CR,LF,0
		.text

option_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	'ُȃIvVł.',CR,LF,0
		.text

* -o ̌Ƀt@Cw肳ĂȂ
no_filename_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	'o̓t@Cw肳Ă܂.',CR,LF,0
		.text

seek_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	'V[NɎs܂.',CR,LF,0
		.text

ioctrl_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	't@C̎Ɏs܂.',CR,LF,0
		.text

setblock_error:
memory_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	'܂.',CR,LF,0
		.text

create_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	't@C쐬o܂.',CR,LF,0
		.text

read_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	't@C̓ǂݍ݂Ɏs܂.',CR,LF,0
		.text

write_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	't@C̏oɎs܂.',CR,LF,0
		.text

no_diskf_error:
		lea	(@f,pc),a0
		bra	print_error_mes
		.data
@@		.dc.b	'fBXN̋󂫗eʂ܂.',CR,LF,0
		.text

print_error_mes:
		move	#STDERR,-(sp)
		pea	(@f,pc)
		DOS	_FPUTS
		move.l	a0,(sp)
		DOS	_FPUTS
		move	#EXIT_FAILURE,(sp)
		DOS	_EXIT2

		.data
@@		.dc.b	program,' : Error : ',0
		.text


* Data Section -------------------------------- *

		.data
		.even


* Block Storage Section ----------------------- *

		.bss				Do not use this section!
		.even
end_:
		.end	start_

* History ------------------------------------- *

version 0.10  95/10/22  (1082bytes)
	CR2LF ĐVK쐬.


* End of File --------------------------------- *
